Blockly.Blocks['forward'] = {
    init: function() {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("vor");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("einen Schritt vorwärts machen");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['links'] = {
    init: function() {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("linksUm");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("auf der aktuellen Kachel um 90° nach links drehen");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['put'] = {
    init: function() {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("gib");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("ein Korn ablegen");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['take'] = {
    init: function() {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("nimm");
        this.setPreviousStatement(true, null);
        this.setNextStatement(true, null);
        this.setColour(260);
        this.setTooltip("ein Korn nehmen");
        this.setHelpUrl("");
    }
};
//Test-Befehle
Blockly.Blocks['iscorn'] = {
    init: function() {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("kornDa");
        this.setOutput(true, null);
        this.setColour(330);
        this.setTooltip("Wahr, wenn mindestens ein Korn auf der Kachel liegt");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['isfrei'] = {
    init: function() {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("vornFrei");
        this.setOutput(true, null);
        this.setColour(330);
        this.setTooltip("Wahr, wenn vorne keine Mauer und auch nicht der Territoriumrand ist");
        this.setHelpUrl("");
    }
};
Blockly.Blocks['isempty'] = {
    init: function() {
        this.appendDummyInput()
            .setAlign(Blockly.ALIGN_CENTRE)
            .appendField("maulLeer");
        this.setOutput(true, null);
        this.setColour(330);
        this.setTooltip("Wahr, wenn der Hamster keine Körner im Maul hat");
        this.setHelpUrl("");
    }
};

//Generator stub

Blockly.JavaScript['forward'] = function(block) {
    var code = 'go();\n';
    return code;
};
Blockly.JavaScript['links'] = function(block) {

    var code = 'changeHamsterDirection();\n';
    return code;
};
Blockly.JavaScript['put'] = function(block) {
    var code = 'putCorn();\n';
    return code;
};
Blockly.JavaScript['take'] = function(block) {
    var code = 'takeCorn();\n';
    return code;
};
//Generator stub: Test-Befehle
Blockly.JavaScript['iscorn'] = function(block) {
    var code = 'isCorn()';
    return [code, Blockly.JavaScript.ORDER_ATOMIC];
};
Blockly.JavaScript['isfrei'] = function(block) {
    var code = 'isFree()';
    return [code, Blockly.JavaScript.ORDER_ATOMIC];
};
Blockly.JavaScript['isempty'] = function(block) {
    var code = 'hasNoCorn()';
    return [code, Blockly.JavaScript.ORDER_ATOMIC];
};

//interpreter

function initApi(interpreter, scope) {

    var wrapperChangeHamsterDirection = function(text) {
        text = text ? text.toString() : '';
        return changeHamsterDirection();
    };
    interpreter.setProperty(scope, 'changeHamsterDirection', interpreter.createNativeFunction(wrapperChangeHamsterDirection));

    var wrapperGo = function(text) {
        text = text ? text.toString() : '';
        return go();
    };
    interpreter.setProperty(scope, 'go', interpreter.createNativeFunction(wrapperGo));

    var wrapperTakeCorn = function(text) {
        text = text ? text.toString() : '';
        return takeCorn();
    };
    interpreter.setProperty(scope, 'takeCorn', interpreter.createNativeFunction(wrapperTakeCorn));

    var wrapperPutCorn = function(text) {
        text = text ? text.toString() : '';
        return putCorn();
    };
    interpreter.setProperty(scope, 'putCorn', interpreter.createNativeFunction(wrapperPutCorn));

    var wrapperIsFree = function(text) {
        text = text ? text.toString() : '';
        return isFree();
    };
    interpreter.setProperty(scope, 'isFree', interpreter.createNativeFunction(wrapperIsFree));

    var wrapperIsCorn = function(text) {
        text = text ? text.toString() : '';
        return isCorn();
    };
    interpreter.setProperty(scope, 'isCorn', interpreter.createNativeFunction(wrapperIsCorn));

    var wrapperHasNoCorn = function(text) {
        text = text ? text.toString() : '';
        return hasNoCorn();
    };
    interpreter.setProperty(scope, 'hasNoCorn', interpreter.createNativeFunction(wrapperHasNoCorn));
}