var cellHeight;
var cellWidth;
var hamsterCorn;
var wallImage = new Image();
var cornImage = new Image();
const minWidthLeftBox = 520;
const minWidthRightBox = 450;

function loadPage() {
    row = 9;
    //column = 10;
    cellHeight = 50;
    cellWidth = 60;
    currentX = 30;
    currentY = 25;
    actorRow = 0;
    actorColumn = 0;
    actorDirection = "south";
    hamsterCorn = 0;
    actorImageSrc = "./images/hamster_bottom.png";
    actorImage.src = actorImageSrc;
    actorImage.onload = function() {
        hamsterMouseEvents();
        drawHamster();
    }
    wallImage.src = "./images/wall.png";
    cornImage.src = "./images/grain.png";
    canvas = document.getElementById("territoryId");

    var windowWidth = getWindowWidth();
    setAreasWidth(windowWidth, true);
    setTitelWidth(windowWidth);
    setAreasHeight(getWindowHeight(), true);

    console.log("rows: ", row, ", columns: ", column);
    initTerritory();

    if (canvas.getContext) {
        territory = canvas.getContext("2d");
        drawBasicTerritory();

    } else {
        alert("Es wird Safari oder Firefox 1.5+ benötigt!");
    }

    saveTemporaryTerritory();

    document.getElementById("playButton").disabled = false;
    document.getElementById("stopButton").disabled = true;
    document.getElementById("pauseButton").disabled = true;
    document.getElementById("number").value = 0;

    Blockly.Themes.Hamster = Blockly.Theme.defineTheme("hamster", {
        'base': Blockly.Themes.Classic,
        'componentStyles': {
            'workspaceBackgroundColour': "rgb(255,245,235)",
            'toolboxBackgroundColour': "rgb(235,209,182)",
            'toolboxForegroundColour': "rgb(139, 69, 19)",
            'flyoutBackgroundColour': "rgb(230,190,138)",
            'flyoutForegroundColour': '#ccc',
            'flyoutOpacity': 1,
            'scrollbarColour': "rgb(235,209,182)",
            'insertionMarkerColour': '#fff',
            'insertionMarkerOpacity': 0.3,
            'scrollbarOpacity': 0.0,
            'cursorColour': '#d0d0d0',
            'blackBackground': '#333'
        }
    });

    workspace = Blockly.inject('blocklyDiv', { toolbox: document.getElementById('toolbox'), theme: Blockly.Themes.Hamster, });
    resizeBlocklyFunc();
    Blockly.svgResize(workspace);
    window.addEventListener('resize', onResizeFunc, false);

    // Touch Event Listeners...
    document.getElementById("wall").addEventListener("touchend", touchEndFunc, false);
    document.getElementById("corn").addEventListener("touchend", touchEndFunc, false);
    document.getElementById("trash").addEventListener("touchend", trashTouchEndFunc, false);
}

function drawBasicTerritory() {
    territory.fillStyle = "rgb(144,238,144)";
    territory.fillRect(0, 0, canvas.width, canvas.height);
    for (var i = 0; i < canvas.width; i += cellWidth) {
        for (var j = 0; j < canvas.height; j += cellHeight) {
            territory.beginPath();
            territory.strokeStyle = "rgb(139, 69, 19)";
            territory.strokeRect(i, j, cellWidth, cellHeight);
        }
    }
}

function initTerritory() {
    createCellContent();
    // fill Territory matrix
    for (var r = 0; r < row; r++) {
        for (var c = 0; c < column; c++) {
            territoryContent[r][c] = new CellContent();
        }
    }

    territoryContent[actorRow][actorColumn].setHamster(true);
}

function returnHamsterOnCanvas() {
    if (canvas.width < currentX || canvas.height < currentY) {
        currentX = 30;
        currentY = 25;
        actorRow = 0;
        actorColumn = 0;
         territoryContent[actorRow][actorColumn].setWall(false);
        territoryContent[actorRow][actorColumn].setHamster(true);
    }
}

function placeHamster() {
    if (currentX >= canvas.width) {
        currentX = cellWidth * column - (cellWidth / 2);

    } else if (currentX <= 0) {
        currentX = cellWidth / 2;
    } else {
        var c = Math.floor(currentX / cellWidth);
        currentX = cellWidth * c + (cellWidth / 2);
    }
    if (currentY >= canvas.height) {
        currentY = cellHeight * row - (cellHeight / 2);

    } else if (currentY <= 0) {
        currentY = cellHeight / 2;
    } else {
        var r = Math.floor(currentY / cellHeight);
        currentY = cellHeight * r + (cellHeight / 2);
    }

    // update Hamster position in Territory Content
    territoryContent[actorRow][actorColumn].setHamster(false);
    actorRow = Math.floor(currentY / cellHeight);
    actorColumn = Math.floor(currentX / cellWidth);
    territoryContent[actorRow][actorColumn].setHamster(true);
}

function drawHamster() {
    if (territoryContent[actorRow][actorColumn].corn) {
        territory.drawImage(actorImage, currentX - 10, currentY - (actorImage.height / 2));
    } else {
        territory.drawImage(actorImage, currentX - (actorImage.width / 2), currentY - (actorImage.height / 2));
    }
}

function hamsterMouseEvents() {
    console.log("hamsterMouseEvents called!");
    canvas.addEventListener("touchmove", function(event) {
        console.log("hamsterMouseEvents touchmove called!");
        var touch = event.targetTouches[0];
        //console.log("hier");
        // Place element where the finger is
        var touchX = touch.pageX - this.offsetLeft;
        var touchY = touch.pageY - this.offsetTop;
        if (touchX >= (currentX - actorImage.width / 2) &&
            touchX <= (currentX + actorImage.width / 2) &&
            touchY >= (currentY - actorImage.height / 2) &&
            touchY <= (currentY + actorImage.height / 2)) {
            currentX = touch.pageX - this.offsetLeft;
            currentY = touch.pageY - this.offsetTop;
            drawBasicTerritory();
            drawTerritoryContent();
            drawHamster();
            event.preventDefault();
        }
    }, false);
    canvas.addEventListener("touchend", function(event) {
        console.log("hamsterMouseEvents touchend called!");
        var c = Math.floor(currentX / cellWidth);
        var r = Math.floor(currentY / cellHeight);
        console.log("hamsterMouseEvents touchend canvas.width: ", canvas.width)
        console.log("hamsterMouseEvents touchend currentX: ", currentX)
        if (currentX > canvas.width || currentY > canvas.height || currentX < 0 || currentY < 0 || true == territoryContent[r][c].getWall()) {
            returnActorToPreviousPosition();
        } else {
            placeHamster();
        }
        // document.getElementById("territoryId").style.cursor = "default";
        drawBasicTerritory();
        drawTerritoryContent();
        drawHamster();
        event.preventDefault();

    }, false);
    canvas.onmousedown = function(e) {
        var mouseX = e.pageX - this.offsetLeft;
        var mouseY = e.pageY - this.offsetTop;
        if (mouseX >= (currentX - actorImage.width / 2) &&
            mouseX <= (currentX + actorImage.width / 2) &&
            mouseY >= (currentY - actorImage.height / 2) &&
            mouseY <= (currentY + actorImage.height / 2)) {
            isDraggable = true;
            document.getElementById("territoryId").style.cursor = "move";
        }
        //console.log("mouseX: ", mouseX, " mouseY: ", mouseY);
    };
    canvas.onmousemove = function(e) {
        if (isDraggable) {
            currentX = e.pageX - this.offsetLeft;
            currentY = e.pageY - this.offsetTop;
            var c = Math.floor(currentX / cellWidth);
            var r = Math.floor(currentY / cellHeight);
            if (true == territoryContent[r][c].getWall()) {
                document.getElementById("territoryId").style.cursor = "no-drop";
            } else {
                document.getElementById("territoryId").style.cursor = "move";
            }
            drawBasicTerritory();
            drawTerritoryContent();
            drawHamster();
        }
    };
    canvas.onmouseup = function(e) {
        if (isDraggable) {
            var c = Math.floor(currentX / cellWidth);
            var r = Math.floor(currentY / cellHeight);
            if (true == territoryContent[r][c].getWall()) {
                returnActorToPreviousPosition();
            } else {
                placeHamster();
            }
            document.getElementById("territoryId").style.cursor = "default";
            drawBasicTerritory();
            drawTerritoryContent();
            drawHamster();
        }
        isDraggable = false;
    };
    canvas.onmouseout = function(e) {
        if (isDraggable) {
            document.getElementById("territoryId").style.cursor = "default";
            returnActorToPreviousPosition();
            drawBasicTerritory();
            drawTerritoryContent();
            drawHamster();
        }
        isDraggable = false;
    };
}

function onSetHamsterCorn() {
    hamsterCorn = parseInt(document.getElementById("number").value);
}

function drawCornAmount(r, c, position) {
    territory.fillStyle = "white";
    territory.fillRect(position[0] - 7, position[1] - 7, 15, 15);
    territory.fillStyle = "black";
    territory.font = "14px Comic Sans MS";
    territory.textAlign = "center";
    territory.fillText(territoryContent[r][c].cornAmount, position[0], position[1] + 6);

}

function drawTerritoryContent() {
    for (var r = 0; r < row; r++) {
        for (var c = 0; c < column; c++) {
            var x = cellWidth * c + (cellWidth / 2);
            var y = cellHeight * r + (cellHeight / 2);
            if (true == territoryContent[r][c].wall) {
                territory.drawImage(wallImage, x - (wallImage.width / 2), y - (wallImage.height / 2));
            } else {
                if (true == territoryContent[r][c].corn) {
                    if (territoryContent[r][c].hamster) {
                        territory.drawImage(cornImage, x - (cellWidth / 2), y - (cornImage.height / 2));
                        x = x - (cellWidth / 2) + 7;
                        drawCornAmount(r, c, [x, y]);
                    } else {
                        territory.drawImage(cornImage, x - (cornImage.width / 2), y - (cornImage.height / 2));
                        drawCornAmount(r, c, [x, y]);
                    }
                }
            }
        }
    }
}

function setCellContent(r, c, position) {
    if (currentDraggableToCanvas == "wallImage") {
        console.log("setCellContent isEmpty: ", territoryContent[r][c].isEmpty())
        if (territoryContent[r][c].isEmpty()) {
            territoryContent[r][c].setWall(true);
            territory.drawImage(wallImage, position[0] - (wallImage.width / 2), position[1] - (wallImage.height / 2));
        }
    } else if (currentDraggableToCanvas == "cornImage") {
        console.log(!territoryContent[r][c].getWall())
        if (!territoryContent[r][c].getWall()) {
            territoryContent[r][c].setCorn(true);
            territoryContent[r][c].incrementCorn();
            console.log("cornamount:", territoryContent[r][c].cornAmount)
            if (territoryContent[r][c].hamster) {
                drawBasicTerritory();
                drawTerritoryContent();
                drawHamster();
            } else {
                territory.drawImage(cornImage, position[0] - (cornImage.width / 2), position[1] - (cornImage.height / 2));
                drawCornAmount(r, c, position);
            }
        }
    }
    currentDraggableToCanvas = " ";
    //console.log(territoryContent);
}

function deleteElement(positionX, positionY) {
    var c = Math.floor(positionX / cellWidth);
    var r = Math.floor(positionY / cellHeight);

    territoryContent[r][c].setWall(false);
    territoryContent[r][c].setCorn(false);
    territoryContent[r][c].setCornAmount(0);

    drawBasicTerritory();
    drawTerritoryContent();
    drawHamster();

    currentDraggableToCanvas = " ";
}